var path    = require('path');
var webpack = require('webpack');

module.exports = {
  devtool      : 'eval',
  entry        : [
    'webpack-dev-server/client?http://localhost:3000',
    'webpack/hot/only-dev-server',
    './src/index'
  ],
  output       : {
    path      : path.join(__dirname, 'dist'),
    filename  : 'bundle.js',
    publicPath: '/static/'
  },
  plugins      : [
    new webpack.HotModuleReplacementPlugin()
  ],
  resolve      : {
    alias: {
      'redux-devtools-diff-monitor': path.join(__dirname, '..', '..', 'lib'),
      'react'                      : path.join(__dirname, 'node_modules', 'react')
    }
  },
  resolveLoader: {
    'fallback': path.join(__dirname, 'node_modules')
  },
  module       : {
    loaders: [{
      test   : /\.js$/,
      loaders: ['react-hot', 'babel'],
      exclude: /node_modules/,
      include: path.join(__dirname, 'src')
    }, {
      test   : /\.js$/,
      loaders: ['react-hot', 'babel'],
      include: path.join(__dirname, '..', '..', 'src')
    }]
  }
};
