'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _style = require('./style');

var _style2 = _interopRequireDefault(_style);

var _diffState = require('../utils/diff-state');

var _diffState2 = _interopRequireDefault(_diffState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ManifestActionComponent = function (_React$Component) {
  _inherits(ManifestActionComponent, _React$Component);

  function ManifestActionComponent() {
    _classCallCheck(this, ManifestActionComponent);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ManifestActionComponent).call(this));

    _this.state = {
      expanded: false
    };
    return _this;
  }

  _createClass(ManifestActionComponent, [{
    key: 'getDiffs',
    value: function getDiffs() {
      var _this2 = this;

      var _props = this.props;
      var currentState = _props.currentState;
      var previousState = _props.previousState;

      return (0, _diffState2.default)(currentState, previousState).map(function (d, i) {
        return _this2.renderDiff(d, i);
      });
    }
  }, {
    key: 'expandAction',
    value: function expandAction() {
      this.setState({
        expanded: !this.state.expanded
      });
    }
  }, {
    key: 'disableAction',
    value: function disableAction() {
      this.props.toggleAction(this.props.index);
    }
  }, {
    key: 'createOldValue',
    value: function createOldValue(diff) {
      if (diff.item) {
        return JSON.stringify(diff.item.lhs);
      }

      return JSON.stringify(diff.lhs);
    }
  }, {
    key: 'createNewValue',
    value: function createNewValue(diff) {
      if (diff.item) {
        return JSON.stringify(diff.item.rhs);
      }

      return JSON.stringify(diff.rhs);
    }
  }, {
    key: 'createPath',
    value: function createPath(diff) {
      var path = [];

      if (diff.path) {
        path = path.concat(diff.path);
      }
      if (typeof diff.index !== 'undefined') {
        path.push(diff.index);
      }
      return path.length ? path.join('.') : '';
    }
  }, {
    key: 'renderDiff',
    value: function renderDiff(diff, index) {
      var oldValue = this.createOldValue(diff);
      var newValue = this.createNewValue(diff);
      var path = this.createPath(diff);

      return _react2.default.createElement(
        'div',
        { key: index },
        path,
        ': ',
        _react2.default.createElement(
          'span',
          { style: _style2.default.oldValue },
          oldValue || 'undefined'
        ),
        _react2.default.createElement(
          'span',
          { style: _style2.default.newValue },
          ' ',
          newValue,
          ' '
        )
      );
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var a = JSON.stringify(this.props.currentState);
      var b = JSON.stringify(nextProps.currentState);
      return a != b || this.state.expanded != nextState.expanded;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var action = _props2.action.action;
      var skipped = _props2.skipped;

      var expanded = this.props.expanded || this.state.expanded;
      var actionBlock = this.state.expanded ? _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'pre',
          { style: _style2.default.actionData },
          JSON.stringify(action)
        )
      ) : null;

      var storeBlock = expanded ? _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: _style2.default.header },
          _react2.default.createElement(
            'span',
            null,
            'Store Mutations'
          )
        ),
        _react2.default.createElement(
          'div',
          {
            className: 'diff',
            style: _style2.default.store
          },
          this.getDiffs()
        )
      ) : null;

      var enableToggle = skipped ? 'enable' : 'disable';

      return _react2.default.createElement(
        'div',
        { className: 'manifest-action-component' },
        _react2.default.createElement(
          'div',
          { style: _style2.default.base },
          _react2.default.createElement(
            'div',
            {
              className: action.type,
              style: [_style2.default.title, skipped && _style2.default.skipped],
              onClick: this.expandAction.bind(this)
            },
            _react2.default.createElement(
              'span',
              null,
              action.type
            ),
            _react2.default.createElement(
              'span',
              { style: _style2.default.toggle, onClick: this.disableAction.bind(this) },
              enableToggle
            )
          ),
          actionBlock,
          storeBlock
        )
      );
    }
  }]);

  return ManifestActionComponent;
}(_react2.default.Component);

ManifestActionComponent.propTypes = {
  diff: _react.PropTypes.array,
  toggleAction: _react.PropTypes.func,
  index: _react.PropTypes.number,
  action: _react.PropTypes.object,
  skipped: _react.PropTypes.bool,
  expanded: _react.PropTypes.bool
};
exports.default = (0, _radium2.default)(ManifestActionComponent);